package com.mygdx.game;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Input;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;

public class Actor {
    static final int DOWN = 0;
    static final int RIGHT = 1;
    static final int UP = 2;
    static final int LEFT = 3;
    int SPEED = 4;
    int maxStep = 5;
    int countStep;
    MyGdxGame game;

    Sprite sprite[][] = new Sprite[4][2];
    Sprite img;
    float x, y;
    int direction;
    int step;

    Actor(float x, float y, String filename, MyGdxGame game) {
        this.game = game;
        this.x = x;
        this.y = y;
        for (int dir = 0; dir < 4; dir++) {
            for (int stp = 0; stp < 2; stp++) {
                sprite[dir][stp] = new Sprite(
                        new Texture(filename + "." + dir + "." + stp + ".png"));
            }
        }
        img = sprite[0][0];
    }

    void execute() {
        if (Gdx.input.isKeyPressed(Input.Keys.DOWN)) {
            move(DOWN);
        } else if (Gdx.input.isKeyPressed(Input.Keys.RIGHT)) {
            move(RIGHT);
        } else if (Gdx.input.isKeyPressed(Input.Keys.UP)) {
            move(UP);
        } else if (Gdx.input.isKeyPressed(Input.Keys.LEFT)) {
            move(LEFT);
        }
    }

    void move(int dir) {
        direction = dir;
        if (direction == DOWN) {
            y -= SPEED;
        } else if (direction == RIGHT) {
            x += SPEED;
        } else if (direction == UP) {
            y += SPEED;
        } else if (direction == LEFT) {
            x -= SPEED;
        }
        countStep++;
        if (countStep >= maxStep) {
            step = (step == 0) ? 1 : 0;
            countStep = 0;
        }
        float h = img.getHeight();
        float w = img.getWidth();
        if (x < 0) x = 0;
        if (x > game.W - w) x = game.W - w;
        if (y < 0) y = 0;
        if (y > game.H - h) y = game.H - h;
    }

    void draw() {
        img = sprite[direction][step];
        img.setPosition(x, y);
        img.draw(game.batch);
    }

    void dispose() {
        for (int dir = 0; dir < 4; dir++) {
            for (int stp = 0; stp < 2; stp++) {
                sprite[dir][stp].getTexture().dispose();
            }
        }
    }
}

