package com.mygdx.game;

import com.badlogic.gdx.ApplicationAdapter;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class MyGdxGame extends ApplicationAdapter {
    SpriteBatch batch;
    List<Actor> actors = new ArrayList<Actor>();
    int H, W;
    Random rand = new Random();

    @Override
    public void create() {
        H = Gdx.graphics.getHeight();
        W = Gdx.graphics.getWidth();
        batch = new SpriteBatch();
        actors.add(new Actor(200, 200, "avatar", this));
        for (int i = 0; i < 10; i++) {
            actors.add(new Mob(rand.nextInt(800), rand.nextInt(600),
                    "cyclope", this));
        }
    }

    public void execute() {
        for (Actor a : actors) a.execute();
    }

    @Override
    public void render() {
        execute();
        Gdx.gl.glClearColor(0, 0.5f, 0, 1);
        Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT);
        batch.begin();
        for (Actor a : actors) a.draw();
        batch.end();
    }

    @Override
    public void dispose() {
        batch.dispose();
        for (Actor a : actors) a.dispose();
    }
}

